module spriteconsumer;

import dsfml.window.all;
import dsfml.system.all;
import dsfml.graphics.all;

import animatedsprite;
import consumer;
import renderer;

class SpriteConsumer : Consumer {
    private Sprite[] sprites;

    this(Renderer renderer) {
	super(renderer);
    }

    void add_sprite(Sprite sprite) {
	this.sprites ~= sprite;
    }

    void draw() {
	 foreach(Sprite sprite; this.sprites) { 
	    this.renderer.draw(sprite);
	 }
    }
}

