module test;

import dsfml.window.all;
import dsfml.system.all;
import dsfml.graphics.all;

import tileconsumer;
import renderer;
import consumer;
import imagecache;
import tilemap;
import tileset;
import xmlmap;
import tools;
import viewconsumer;
import animatedsprite;
import spriteconsumer;

int main(char[][] args) {
    Cache cache = new Cache("gfx");
    Tilemap map = parse_map(cache, read_file_contents("map-example.xml"));
    Renderer render = new Renderer("Blubb", 600, 480, 32);
//    render.add_consumer(new InteractiveViewConsumer(render));
//    TileConsumer consumer = new TileConsumer(render, map);
//    render.add_consumer(consumer);
    SpriteConsumer c = new SpriteConsumer(render);
    AnimatedSprite s = new AnimatedSprite;
    s.setX(10);
    s.setY(10);
    Animation a = new Animation;
    a.add_frame(map.tileset.tiles[0], 10);
    a.add_frame(map.tileset.tiles[1], 10);
//    s.setImage(map.tileset.tiles[0]);
    s.play_animation(a, true);
    c.add_sprite(s);
    render.add_consumer(c);

    render.mainloop();
    return 0; 
}
